

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.*;
import javax.swing.text.StyledEditorKit;
@SuppressWarnings({"serial","unused"})
public class CodeEditor extends JPanel implements ActionListener {
	JButton salva = new JButton("Save Code");
	JEditorPane field = new JEditorPane();
	public CodeEditor() {
		setLayout(null);
		setLayoutDisposement();
		add(field);add(salva);
		salva.addActionListener(this);
        field.addKeyListener(new CodeKeyListener());
		ClipboardPopupMenu pop = ClipboardPopupMenu.install(field);
		pop = ClipboardPopupMenu.parsePopupMenu(pop);
	}
	public void setLayoutDisposement() {
		field.setEditorKit(new StyledEditorKit());
		field.setBounds(20,30,650,440);
		salva.setBounds(20,475,650,40);
	}
	public void actionPerformed(ActionEvent e) {
		SaveFileWindow save;
		save = new SaveFileWindow(field.getText(),true);
	}
	public class CodeKeyListener implements KeyListener {
		int level = 0;
		public void keyPressed(KeyEvent k) {
		}
		public void keyReleased(KeyEvent k) {
		}
		public void keyTyped(KeyEvent k) {
			if(k.getKeyChar()=='{')
				level=level+2;
			if(k.getKeyChar()=='}') 
				level=level-2;
			if(k.getKeyChar()=='\n') {
				if(level>0) {
					int temp = level;
					String space = "";
					while(level >= 0) {
						space = space + " ";
						level--;
					}
					level = temp;
					field.setText(field.getText()+space);
				}
			}
		}
	}
}