


import javax.swing.*;
import javax.swing.text.html.HTMLEditorKit;

import Func.Global;

import java.awt.*;
import java.awt.event.*;

@SuppressWarnings({ "serial", "unused" })
public class HtmlWidget extends JPanel implements
ActionListener {
	JEditorPane label = new JEditorPane();
    JTextArea htmlTextArea = new JTextArea();
    ClipboardPopupMenu pop = ClipboardPopupMenu.installForComponent(label);
    ClipboardPopupMenu cpb = ClipboardPopupMenu.installForComponent(label);
    public HtmlWidget() {
        setLayout(/**new BoxLayout(this, BoxLayout.LINE_AXIS)**/null);
        label.setEditorKit(new HTMLEditorKit());
        String initialText = Global.HtmlTextEsempio;

        htmlTextArea = new JTextArea(15, 10);
        htmlTextArea.setText(initialText);
  	    pop.addCopyFunction("Copia");
  	    pop.addCutFunction("Taglia");
  	    pop.addPasteFunction("Incolla");
  	    pop.addClearFunction("Clear");
  	    cpb.addCopyFunction("Copia");
  	    cpb.addCutFunction("Taglia");
  	    cpb.addPasteFunction("Incolla");
  	    cpb.addClearFunction("Clear");
        JScrollPane scrollPane = new JScrollPane(htmlTextArea);
        JButton save = new JButton("Save It");

        JButton changeTheLabel = new JButton("Preview");
        changeTheLabel.setMnemonic(KeyEvent.VK_C);
        changeTheLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
        changeTheLabel.addActionListener(this);
        save.addActionListener(this);
        save.setMnemonic(KeyEvent.VK_C);
        save.setAlignmentX(Component.CENTER_ALIGNMENT);

        label.setText(initialText);
        JPanel leftPanel = new JPanel();
        leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.PAGE_AXIS));
        leftPanel.setBorder(BorderFactory.createCompoundBorder(
                BorderFactory.createTitledBorder(
                    "HTML Visual Editor"),
                BorderFactory.createEmptyBorder(10,10,10,10)));
        leftPanel.add(scrollPane);
        leftPanel.add(Box.createRigidArea(new Dimension(0,10)));
        leftPanel.add(changeTheLabel);
        leftPanel.add(save);
        
        leftPanel.setBackground(Color.gray);

        JPanel rightPanel = new JPanel();
        rightPanel.setLayout(new BoxLayout(rightPanel, BoxLayout.PAGE_AXIS));
        rightPanel.setBorder(BorderFactory.createCompoundBorder(
                        BorderFactory.createTitledBorder("Preview HTML"),
                        BorderFactory.createEmptyBorder(10,10,10,10)));
        rightPanel.setBackground(Color.gray);
        rightPanel.add(label);

        
        
        setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
        add(leftPanel);
        add(Box.createRigidArea(new Dimension(5,0)));
        add(rightPanel);
        
        leftPanel.setBounds(15,20,320,480);
        rightPanel.setBounds(342,20,340,480);
    }

    // Eventi... Eventi... Ancora Eventi...
    public void actionPerformed(ActionEvent e) {
    	if(e.getActionCommand().compareTo("Preview")==0) {
            label.setText(htmlTextArea.getText());
    	}
    	if(e.getActionCommand().compareTo("Save It")==0) {
			SaveFileWindow s_file=new SaveFileWindow(htmlTextArea.getText());
    	}
    }
    
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("HtmlDemo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        frame.add(new HtmlWidget());

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void Run() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
	        UIManager.put("swing.boldMetal", Boolean.FALSE);
	        createAndShowGUI();
            }
        });
    }
    
}
