import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;


public class SaveFileWindow {
	public SaveFileWindow(String s) {
		JFileChooser j = new JFileChooser("C:\\");
		FileNameExtensionFilter html=new FileNameExtensionFilter("Pagina Web (*.html)","html");
		FileNameExtensionFilter text=new FileNameExtensionFilter("Plain Text (*.txt)","txt");
		FileNameExtensionFilter xml=new FileNameExtensionFilter("Documento XML (*.xml)","xml");
		j.removeChoosableFileFilter(j.getAcceptAllFileFilter());
		j.addChoosableFileFilter(xml);
		j.addChoosableFileFilter(text);
		j.setFileFilter(html);
		j.showSaveDialog(j);
		File f = j.getSelectedFile();
		if(!f.isFile()) {
			f = new File("default.html");
		}
		if(accept(f)) {
			SaveFile.Run(f.getAbsolutePath(),s);
		}
		else {
			SaveFile.Run(f.getAbsolutePath()+".html", s);
		}
	}
	public SaveFileWindow(String s, boolean prog) {
		JFileChooser j = new JFileChooser("C:\\");
		FileNameExtensionFilter c=new FileNameExtensionFilter("File C (*.c)","c");
		FileNameExtensionFilter java=new FileNameExtensionFilter("File JAVA (*.java)","java");
		FileNameExtensionFilter pascal=new FileNameExtensionFilter("File Pascal (*.pas)","pas");
		j.removeChoosableFileFilter(j.getAcceptAllFileFilter());
		j.addChoosableFileFilter(java);
		j.addChoosableFileFilter(pascal);
		j.setFileFilter(c);
		j.showSaveDialog(j);
		File f = j.getSelectedFile();
		if(accept(f)==true) {
				SaveFile.Run(f.getAbsolutePath(),s);
		}
		else {
				SaveFile.Run(f.getAbsolutePath()+".java", s);
		}
	}
	public SaveFileWindow() {
		
	}
	public class AnnullaException {
		
	}
	public File OpenFileWindow() {
		JFileChooser j = new JFileChooser("C:\\");
		FileNameExtensionFilter html=new FileNameExtensionFilter("Pagina Web (*.html)","html");
		FileNameExtensionFilter text=new FileNameExtensionFilter("Plain Text (*.txt)","txt");
		FileNameExtensionFilter xml=new FileNameExtensionFilter("Documento XML (*.xml)","xml");
		j.removeChoosableFileFilter(j.getAcceptAllFileFilter());
		j.addChoosableFileFilter(xml);
		j.addChoosableFileFilter(text);
		j.setFileFilter(html);
		j.showOpenDialog(j);
		return j.getSelectedFile();
	}
	public boolean accept(File file) {
	   final String[] okFileExtensions = new String[] {"html", "xml", "txt", "c", "java", "pas"};
	   for (String extension : okFileExtensions) {
		 if (file.getName().toLowerCase().endsWith(extension)) {
		    return true;
		 }
	   }
	   return false;
	}
    public String ReadFile(String filePath)
    throws java.io.IOException{
        StringBuffer fileData = new StringBuffer(1000);
        BufferedReader reader = new BufferedReader(
                new FileReader(filePath));
        char[] buf = new char[1024];
        int numRead=0;
        while((numRead=reader.read(buf)) != -1){
            String readData = String.valueOf(buf, 0, numRead);
            fileData.append(readData);
            buf = new char[1024];
        }
        reader.close();
        return fileData.toString();
    }
}